package net.minecraft.src;

import java.nio.IntBuffer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Random;

import net.minecraft.client.Minecraft;

import org.lwjgl.opengl.ARBOcclusionQuery;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL15;

public class RenderGlobal implements IWorldAccess {
	public List tileEntities = new ArrayList();
	private World worldObj;
	private RenderEngine renderEngine;
	private List worldRenderersToUpdate = new ArrayList();
	private WorldRenderer[] sortedWorldRenderers;
	private WorldRenderer[] worldRenderers;
	private int renderChunksWide;
	private int renderChunksTall;
	private int renderChunksDeep;
	private int field_1440_s;
	private Minecraft mc;
	private RenderBlocks field_1438_u;
	private IntBuffer field_1437_v;
	private boolean occlusionEnabled = false;
	private int cloudOffsetX = 0;
	private int starGLCallList;
	private int field_1433_z;
	private int field_1432_A;
	private int field_1431_B;
	private int field_1430_C;
	private int field_1429_D;
	private int field_1428_E;
	private int field_1427_F;
	private int field_1426_G;
	private int renderDistance = -1;
	private int field_1424_I = 2;
	private int field_1423_J;
	private int field_1422_K;
	private int field_1421_L;
	int[] field_1457_b = new int[50000];
	IntBuffer occlusionResult = GLAllocation.createDirectIntBuffer(64);
	private int renderersLoaded;
	private int renderersBeingClipped;
	private int renderersBeingOccluded;
	private int renderersBeingRendered;
	private int renderersSkippingRenderPass;
	private int field_21156_R;
	private List field_1415_R = new ArrayList();
	private RenderList[] field_1414_S = new RenderList[]{new RenderList(), new RenderList(), new RenderList(), new RenderList()};
	int field_1455_d = 0;
	int field_1454_e = GLAllocation.generateDisplayLists(1);
	double prevSortX = -9999.0D;
	double prevSortY = -9999.0D;
	double prevSortZ = -9999.0D;
	public float field_1450_i;
	int frustrumCheckOffset = 0;

	public RenderGlobal(Minecraft minecraft1, RenderEngine renderEngine2) {
		this.mc = minecraft1;
		this.renderEngine = renderEngine2;
		byte b3 = 64;
		this.field_1440_s = GLAllocation.generateDisplayLists(b3 * b3 * b3 * 3);
		this.occlusionEnabled = minecraft1.getOpenGlCapsChecker().checkARBOcclusion();
		if(this.occlusionEnabled) {
			this.occlusionResult.clear();
			this.field_1437_v = GLAllocation.createDirectIntBuffer(b3 * b3 * b3);
			this.field_1437_v.clear();
			this.field_1437_v.position(0);
			this.field_1437_v.limit(b3 * b3 * b3);
			ARBOcclusionQuery.glGenQueriesARB(this.field_1437_v);
		}

		this.starGLCallList = GLAllocation.generateDisplayLists(3);
		GL11.glPushMatrix();
		GL11.glNewList(this.starGLCallList, GL11.GL_COMPILE);
		this.renderStars();
		GL11.glEndList();
		GL11.glPopMatrix();
		Tessellator tessellator4 = Tessellator.instance;
		this.field_1433_z = this.starGLCallList + 1;
		GL11.glNewList(this.field_1433_z, GL11.GL_COMPILE);
		byte b5 = 64;
		int i6 = 256 / b5 + 2;
		float f7 = 16.0F;

		int i8;
		int i9;
		for(i8 = -b5 * i6; i8 <= b5 * i6; i8 += b5) {
			for(i9 = -b5 * i6; i9 <= b5 * i6; i9 += b5) {
				tessellator4.startDrawingQuads();
				tessellator4.addVertex((double)(i8 + 0), (double)f7, (double)(i9 + 0));
				tessellator4.addVertex((double)(i8 + b5), (double)f7, (double)(i9 + 0));
				tessellator4.addVertex((double)(i8 + b5), (double)f7, (double)(i9 + b5));
				tessellator4.addVertex((double)(i8 + 0), (double)f7, (double)(i9 + b5));
				tessellator4.draw();
			}
		}

		GL11.glEndList();
		this.field_1432_A = this.starGLCallList + 2;
		GL11.glNewList(this.field_1432_A, GL11.GL_COMPILE);
		f7 = -16.0F;
		tessellator4.startDrawingQuads();

		for(i8 = -b5 * i6; i8 <= b5 * i6; i8 += b5) {
			for(i9 = -b5 * i6; i9 <= b5 * i6; i9 += b5) {
				tessellator4.addVertex((double)(i8 + b5), (double)f7, (double)(i9 + 0));
				tessellator4.addVertex((double)(i8 + 0), (double)f7, (double)(i9 + 0));
				tessellator4.addVertex((double)(i8 + 0), (double)f7, (double)(i9 + b5));
				tessellator4.addVertex((double)(i8 + b5), (double)f7, (double)(i9 + b5));
			}
		}

		tessellator4.draw();
		GL11.glEndList();
	}

	private void renderStars() {
		Random random1 = new Random(10842L);
		Tessellator tessellator2 = Tessellator.instance;
		tessellator2.startDrawingQuads();

		for(int i3 = 0; i3 < 1500; ++i3) {
			double d4 = (double)(random1.nextFloat() * 2.0F - 1.0F);
			double d6 = (double)(random1.nextFloat() * 2.0F - 1.0F);
			double d8 = (double)(random1.nextFloat() * 2.0F - 1.0F);
			double d10 = (double)(0.25F + random1.nextFloat() * 0.25F);
			double d12 = d4 * d4 + d6 * d6 + d8 * d8;
			if(d12 < 1.0D && d12 > 0.01D) {
				d12 = 1.0D / Math.sqrt(d12);
				d4 *= d12;
				d6 *= d12;
				d8 *= d12;
				double d14 = d4 * 100.0D;
				double d16 = d6 * 100.0D;
				double d18 = d8 * 100.0D;
				double d20 = Math.atan2(d4, d8);
				double d22 = Math.sin(d20);
				double d24 = Math.cos(d20);
				double d26 = Math.atan2(Math.sqrt(d4 * d4 + d8 * d8), d6);
				double d28 = Math.sin(d26);
				double d30 = Math.cos(d26);
				double d32 = random1.nextDouble() * Math.PI * 2.0D;
				double d34 = Math.sin(d32);
				double d36 = Math.cos(d32);

				for(int i38 = 0; i38 < 4; ++i38) {
					double d39 = 0.0D;
					double d41 = (double)((i38 & 2) - 1) * d10;
					double d43 = (double)((i38 + 1 & 2) - 1) * d10;
					double d45 = d41 * d36 - d43 * d34;
					double d47 = d43 * d36 + d41 * d34;
					double d49 = d45 * d28 + d39 * d30;
					double d51 = d39 * d28 - d45 * d30;
					double d53 = d51 * d22 - d47 * d24;
					double d55 = d47 * d22 + d51 * d24;
					tessellator2.addVertex(d14 + d53, d16 + d49, d18 + d55);
				}
			}
		}

		tessellator2.draw();
	}

	public void func_946_a(World world1) {
		if(this.worldObj != null) {
			this.worldObj.removeWorldAccess(this);
		}

		this.prevSortX = -9999.0D;
		this.prevSortY = -9999.0D;
		this.prevSortZ = -9999.0D;
		RenderManager.instance.func_852_a(world1);
		this.worldObj = world1;
		this.field_1438_u = new RenderBlocks(world1);
		if(world1 != null) {
			world1.addWorldAccess(this);
			this.loadRenderers();
		}

	}

	public void loadRenderers() {
		Block.leaves.setGraphicsLevel(this.mc.gameSettings.fancyGraphics);
		this.renderDistance = this.mc.gameSettings.renderDistance;
		int i1;
		if(this.worldRenderers != null) {
			for(i1 = 0; i1 < this.worldRenderers.length; ++i1) {
				this.worldRenderers[i1].func_1204_c();
			}
		}

		i1 = 64 << 3 - this.renderDistance;
		if(i1 > 400) {
			i1 = 400;
		}

		this.renderChunksWide = i1 / 16 + 1;
		this.renderChunksTall = 8;
		this.renderChunksDeep = i1 / 16 + 1;
		this.worldRenderers = new WorldRenderer[this.renderChunksWide * this.renderChunksTall * this.renderChunksDeep];
		this.sortedWorldRenderers = new WorldRenderer[this.renderChunksWide * this.renderChunksTall * this.renderChunksDeep];
		int i2 = 0;
		int i3 = 0;
		this.field_1431_B = 0;
		this.field_1430_C = 0;
		this.field_1429_D = 0;
		this.field_1428_E = this.renderChunksWide;
		this.field_1427_F = this.renderChunksTall;
		this.field_1426_G = this.renderChunksDeep;

		int i4;
		for(i4 = 0; i4 < this.worldRenderersToUpdate.size(); ++i4) {
			((WorldRenderer)this.worldRenderersToUpdate.get(i4)).needsUpdate = false;
		}

		this.worldRenderersToUpdate.clear();
		this.tileEntities.clear();

		for(i4 = 0; i4 < this.renderChunksWide; ++i4) {
			for(int i5 = 0; i5 < this.renderChunksTall; ++i5) {
				for(int i6 = 0; i6 < this.renderChunksDeep; ++i6) {
					this.worldRenderers[(i6 * this.renderChunksTall + i5) * this.renderChunksWide + i4] = new WorldRenderer(this.worldObj, this.tileEntities, i4 * 16, i5 * 16, i6 * 16, 16, this.field_1440_s + i2);
					if(this.occlusionEnabled) {
						this.worldRenderers[(i6 * this.renderChunksTall + i5) * this.renderChunksWide + i4].field_1732_z = this.field_1437_v.get(i3);
					}

					this.worldRenderers[(i6 * this.renderChunksTall + i5) * this.renderChunksWide + i4].isWaitingOnOcclusionQuery = false;
					this.worldRenderers[(i6 * this.renderChunksTall + i5) * this.renderChunksWide + i4].isVisible = true;
					this.worldRenderers[(i6 * this.renderChunksTall + i5) * this.renderChunksWide + i4].isInFrustum = true;
					this.worldRenderers[(i6 * this.renderChunksTall + i5) * this.renderChunksWide + i4].field_1735_w = i3++;
					this.worldRenderers[(i6 * this.renderChunksTall + i5) * this.renderChunksWide + i4].markDirty();
					this.sortedWorldRenderers[(i6 * this.renderChunksTall + i5) * this.renderChunksWide + i4] = this.worldRenderers[(i6 * this.renderChunksTall + i5) * this.renderChunksWide + i4];
					this.worldRenderersToUpdate.add(this.worldRenderers[(i6 * this.renderChunksTall + i5) * this.renderChunksWide + i4]);
					i2 += 3;
				}
			}
		}

		if(this.worldObj != null) {
			EntityLiving entityLiving7 = this.mc.renderViewEntity;
			if(entityLiving7 != null) {
				this.markRenderersForNewPosition(MathHelper.floor_double(entityLiving7.posX), MathHelper.floor_double(entityLiving7.posY), MathHelper.floor_double(entityLiving7.posZ));
				Arrays.sort(this.sortedWorldRenderers, new EntitySorter(entityLiving7));
			}
		}

		this.field_1424_I = 2;
	}

	public void renderEntities(Vec3D vec3D1, ICamera iCamera2, float f3) {
		if(this.field_1424_I > 0) {
			--this.field_1424_I;
		} else {
			TileEntityRenderer.instance.cacheActiveRenderInfo(this.worldObj, this.renderEngine, this.mc.fontRenderer, this.mc.renderViewEntity, f3);
			RenderManager.instance.cacheActiveRenderInfo(this.worldObj, this.renderEngine, this.mc.fontRenderer, this.mc.renderViewEntity, this.mc.gameSettings, f3);
			this.field_1423_J = 0;
			this.field_1422_K = 0;
			this.field_1421_L = 0;
			EntityLiving entityLiving4 = this.mc.renderViewEntity;
			RenderManager.renderPosX = entityLiving4.lastTickPosX + (entityLiving4.posX - entityLiving4.lastTickPosX) * (double)f3;
			RenderManager.renderPosY = entityLiving4.lastTickPosY + (entityLiving4.posY - entityLiving4.lastTickPosY) * (double)f3;
			RenderManager.renderPosZ = entityLiving4.lastTickPosZ + (entityLiving4.posZ - entityLiving4.lastTickPosZ) * (double)f3;
			TileEntityRenderer.staticPlayerX = entityLiving4.lastTickPosX + (entityLiving4.posX - entityLiving4.lastTickPosX) * (double)f3;
			TileEntityRenderer.staticPlayerY = entityLiving4.lastTickPosY + (entityLiving4.posY - entityLiving4.lastTickPosY) * (double)f3;
			TileEntityRenderer.staticPlayerZ = entityLiving4.lastTickPosZ + (entityLiving4.posZ - entityLiving4.lastTickPosZ) * (double)f3;
			List list5 = this.worldObj.getLoadedEntityList();
			this.field_1423_J = list5.size();

			int i6;
			Entity entity7;
			for(i6 = 0; i6 < this.worldObj.field_27173_e.size(); ++i6) {
				entity7 = (Entity)this.worldObj.field_27173_e.get(i6);
				++this.field_1422_K;
				if(entity7.isInRangeToRenderVec3D(vec3D1)) {
					RenderManager.instance.renderEntity(entity7, f3);
				}
			}

			for(i6 = 0; i6 < list5.size(); ++i6) {
				entity7 = (Entity)list5.get(i6);
				if(entity7.isInRangeToRenderVec3D(vec3D1) && iCamera2.isBoundingBoxInFrustum(entity7.boundingBox) && (entity7 != this.mc.renderViewEntity || this.mc.gameSettings.thirdPersonView || this.mc.renderViewEntity.isPlayerSleeping()) && this.worldObj.blockExists(MathHelper.floor_double(entity7.posX), MathHelper.floor_double(entity7.posY), MathHelper.floor_double(entity7.posZ))) {
					++this.field_1422_K;
					RenderManager.instance.renderEntity(entity7, f3);
				}
			}

			for(i6 = 0; i6 < this.tileEntities.size(); ++i6) {
				TileEntityRenderer.instance.renderTileEntity((TileEntity)this.tileEntities.get(i6), f3);
			}
		}

	}

	public String func_953_b() {
		FontRenderer fontRenderer1 = this.mc.fontRenderer;
		String string2 = "/";
		fontRenderer1.drawStringWithShadow("Rendered", 2, 12, 16579668);
		fontRenderer1.drawStringWithShadow(string2, 2 + fontRenderer1.getStringWidth("Rendered"), 12, 5569788);
		fontRenderer1.drawStringWithShadow("total: ", 2 + fontRenderer1.getStringWidth("Rendered" + string2), 12, 16558080);
		fontRenderer1.drawStringWithShadow("" + this.renderersBeingRendered, 2 + fontRenderer1.getStringWidth("Rendered" + string2 + "total: "), 12, 16579668);
		fontRenderer1.drawStringWithShadow(string2, 2 + fontRenderer1.getStringWidth("Rendered" + string2 + "total: " + this.renderersBeingRendered), 12, 5569788);
		fontRenderer1.drawStringWithShadow("" + this.renderersLoaded, 2 + fontRenderer1.getStringWidth("Rendered" + string2 + "total: " + this.renderersBeingRendered + string2), 12, 16558080);
		fontRenderer1.drawStringWithShadow("Culled Renders: ", 2, 22, 43260);
		fontRenderer1.drawStringWithShadow("" + this.renderersBeingClipped, 2 + fontRenderer1.getStringWidth("Culled Renders: "), 22, 5569620);
		fontRenderer1.drawStringWithShadow("Removed Renders: ", 2, 32, 43260);
		fontRenderer1.drawStringWithShadow("" + this.renderersBeingOccluded, 2 + fontRenderer1.getStringWidth("Removed Renders: "), 32, 5569620);
		fontRenderer1.drawStringWithShadow("Skipped Renders: ", 2, 42, 43260);
		fontRenderer1.drawStringWithShadow("" + this.renderersSkippingRenderPass, 2 + fontRenderer1.getStringWidth("Skipped Renders: "), 42, 5569620);
		return "";
	}

	public String func_957_c() {
		FontRenderer fontRenderer1 = this.mc.fontRenderer;
		String string2 = "/";
		fontRenderer1.drawStringWithShadow("Rendered Entities: ", 2, 52, 16579668);
		fontRenderer1.drawStringWithShadow("" + this.field_1422_K, 2 + fontRenderer1.getStringWidth("Rendered Entities: "), 52, 5569788);
		fontRenderer1.drawStringWithShadow(string2, 2 + fontRenderer1.getStringWidth("Rendered Entities: " + this.field_1422_K), 52, 16579668);
		fontRenderer1.drawStringWithShadow("" + this.field_1423_J, 2 + fontRenderer1.getStringWidth("Rendered Entities: " + this.field_1422_K + string2), 52, 16558080);
		fontRenderer1.drawStringWithShadow("Entities Hidden: ", 2, 62, 16579668);
		fontRenderer1.drawStringWithShadow("" + this.field_1421_L, 2 + fontRenderer1.getStringWidth("Entities Hidden: "), 62, 5569788);
		fontRenderer1.drawStringWithShadow("Culled Entities: ", 2, 72, 16579668);
		fontRenderer1.drawStringWithShadow("" + (this.field_1423_J - this.field_1421_L - this.field_1422_K), 2 + fontRenderer1.getStringWidth("Culled Entities: "), 72, 5569788);
		return "";
	}

	private void markRenderersForNewPosition(int i1, int i2, int i3) {
		i1 -= 8;
		i2 -= 8;
		i3 -= 8;
		this.field_1431_B = Integer.MAX_VALUE;
		this.field_1430_C = Integer.MAX_VALUE;
		this.field_1429_D = Integer.MAX_VALUE;
		this.field_1428_E = Integer.MIN_VALUE;
		this.field_1427_F = Integer.MIN_VALUE;
		this.field_1426_G = Integer.MIN_VALUE;
		int i4 = this.renderChunksWide * 16;
		int i5 = i4 / 2;

		for(int i6 = 0; i6 < this.renderChunksWide; ++i6) {
			int i7 = i6 * 16;
			int i8 = i7 + i5 - i1;
			if(i8 < 0) {
				i8 -= i4 - 1;
			}

			i8 /= i4;
			i7 -= i8 * i4;
			if(i7 < this.field_1431_B) {
				this.field_1431_B = i7;
			}

			if(i7 > this.field_1428_E) {
				this.field_1428_E = i7;
			}

			for(int i9 = 0; i9 < this.renderChunksDeep; ++i9) {
				int i10 = i9 * 16;
				int i11 = i10 + i5 - i3;
				if(i11 < 0) {
					i11 -= i4 - 1;
				}

				i11 /= i4;
				i10 -= i11 * i4;
				if(i10 < this.field_1429_D) {
					this.field_1429_D = i10;
				}

				if(i10 > this.field_1426_G) {
					this.field_1426_G = i10;
				}

				for(int i12 = 0; i12 < this.renderChunksTall; ++i12) {
					int i13 = i12 * 16;
					if(i13 < this.field_1430_C) {
						this.field_1430_C = i13;
					}

					if(i13 > this.field_1427_F) {
						this.field_1427_F = i13;
					}

					WorldRenderer worldRenderer14 = this.worldRenderers[(i9 * this.renderChunksTall + i12) * this.renderChunksWide + i6];
					boolean z15 = worldRenderer14.needsUpdate;
					worldRenderer14.setPosition(i7, i13, i10);
					if(!z15 && worldRenderer14.needsUpdate) {
						this.worldRenderersToUpdate.add(worldRenderer14);
					}
				}
			}
		}

	}

	public int sortAndRender(EntityLiving entityLiving1, int i2, double d3) {
		for(int i5 = 0; i5 < 10; ++i5) {
			this.field_21156_R = (this.field_21156_R + 1) % this.worldRenderers.length;
			WorldRenderer worldRenderer6 = this.worldRenderers[this.field_21156_R];
			if(worldRenderer6.needsUpdate && !this.worldRenderersToUpdate.contains(worldRenderer6)) {
				this.worldRenderersToUpdate.add(worldRenderer6);
			}
		}

		if(this.mc.gameSettings.renderDistance != this.renderDistance) {
			this.loadRenderers();
		}

		if(i2 == 0) {
			this.renderersLoaded = 0;
			this.renderersBeingClipped = 0;
			this.renderersBeingOccluded = 0;
			this.renderersBeingRendered = 0;
			this.renderersSkippingRenderPass = 0;
		}

		double d35 = entityLiving1.lastTickPosX + (entityLiving1.posX - entityLiving1.lastTickPosX) * d3;
		double d7 = entityLiving1.lastTickPosY + (entityLiving1.posY - entityLiving1.lastTickPosY) * d3;
		double d9 = entityLiving1.lastTickPosZ + (entityLiving1.posZ - entityLiving1.lastTickPosZ) * d3;
		double d11 = entityLiving1.posX - this.prevSortX;
		double d13 = entityLiving1.posY - this.prevSortY;
		double d15 = entityLiving1.posZ - this.prevSortZ;
		if(d11 * d11 + d13 * d13 + d15 * d15 > 16.0D) {
			this.prevSortX = entityLiving1.posX;
			this.prevSortY = entityLiving1.posY;
			this.prevSortZ = entityLiving1.posZ;
			this.markRenderersForNewPosition(MathHelper.floor_double(entityLiving1.posX), MathHelper.floor_double(entityLiving1.posY), MathHelper.floor_double(entityLiving1.posZ));
			Arrays.sort(this.sortedWorldRenderers, new EntitySorter(entityLiving1));
		}

		byte b17 = 0;
		int i18;
		if(this.occlusionEnabled && this.mc.gameSettings.field_27342_h && !this.mc.gameSettings.anaglyph && i2 == 0) {
			byte b19 = 0;
			int i20 = 16;
			this.checkOcclusionQueryResult(b19, i20);

			int i21;
			for(i21 = b19; i21 < i20; ++i21) {
				this.sortedWorldRenderers[i21].isVisible = true;
			}

			i18 = b17 + this.renderSortedRenderers(b19, i20, i2, d3);

			do {
				i21 = i20;
				i20 *= 2;
				if(i20 > this.sortedWorldRenderers.length) {
					i20 = this.sortedWorldRenderers.length;
				}

				GL11.glDisable(GL11.GL_TEXTURE_2D);
				GL11.glDisable(GL11.GL_LIGHTING);
				GL11.glDisable(GL11.GL_ALPHA_TEST);
				GL11.glDisable(GL11.GL_FOG);
				GL11.glColorMask(false, false, false, false);
				GL11.glDepthMask(false);
				this.checkOcclusionQueryResult(i21, i20);
				GL11.glPushMatrix();
				float f22 = 0.0F;
				float f23 = 0.0F;
				float f24 = 0.0F;

				for(int i25 = i21; i25 < i20; ++i25) {
					if(this.sortedWorldRenderers[i25].skipAllRenderPasses()) {
						this.sortedWorldRenderers[i25].isInFrustum = false;
					} else {
						if(!this.sortedWorldRenderers[i25].isInFrustum) {
							this.sortedWorldRenderers[i25].isVisible = true;
						}

						if(this.sortedWorldRenderers[i25].isInFrustum && !this.sortedWorldRenderers[i25].isWaitingOnOcclusionQuery) {
							float f26 = MathHelper.sqrt_float(this.sortedWorldRenderers[i25].distanceToEntitySquared(entityLiving1));
							int i27 = (int)(1.0F + f26 / 128.0F);
							if(this.cloudOffsetX % i27 == i25 % i27) {
								WorldRenderer worldRenderer28 = this.sortedWorldRenderers[i25];
								float f29 = (float)((double)worldRenderer28.field_1755_i - d35);
								float f30 = (float)((double)worldRenderer28.field_1754_j - d7);
								float f31 = (float)((double)worldRenderer28.field_1753_k - d9);
								float f32 = f29 - f22;
								float f33 = f30 - f23;
								float f34 = f31 - f24;
								if(f32 != 0.0F || f33 != 0.0F || f34 != 0.0F) {
									GL11.glTranslatef(f32, f33, f34);
									f22 += f32;
									f23 += f33;
									f24 += f34;
								}

								ARBOcclusionQuery.glBeginQueryARB(GL15.GL_SAMPLES_PASSED, this.sortedWorldRenderers[i25].field_1732_z);
								this.sortedWorldRenderers[i25].callOcclusionQueryList();
								ARBOcclusionQuery.glEndQueryARB(GL15.GL_SAMPLES_PASSED);
								this.sortedWorldRenderers[i25].isWaitingOnOcclusionQuery = true;
							}
						}
					}
				}

				GL11.glPopMatrix();
				GL11.glColorMask(true, true, true, true);
				GL11.glDepthMask(true);
				GL11.glEnable(GL11.GL_TEXTURE_2D);
				GL11.glEnable(GL11.GL_ALPHA_TEST);
				GL11.glEnable(GL11.GL_FOG);
				i18 += this.renderSortedRenderers(i21, i20, i2, d3);
			} while(i20 < this.sortedWorldRenderers.length);
		} else {
			i18 = b17 + this.renderSortedRenderers(0, this.sortedWorldRenderers.length, i2, d3);
		}

		return i18;
	}

	private void checkOcclusionQueryResult(int i1, int i2) {
		for(int i3 = i1; i3 < i2; ++i3) {
			if(this.sortedWorldRenderers[i3].isWaitingOnOcclusionQuery) {
				this.occlusionResult.clear();
				ARBOcclusionQuery.glGetQueryObjectuARB(this.sortedWorldRenderers[i3].field_1732_z, GL15.GL_QUERY_RESULT_AVAILABLE, this.occlusionResult);
				if(this.occlusionResult.get(0) != 0) {
					this.sortedWorldRenderers[i3].isWaitingOnOcclusionQuery = false;
					this.occlusionResult.clear();
					ARBOcclusionQuery.glGetQueryObjectuARB(this.sortedWorldRenderers[i3].field_1732_z, GL15.GL_QUERY_RESULT, this.occlusionResult);
					this.sortedWorldRenderers[i3].isVisible = this.occlusionResult.get(0) != 0;
				}
			}
		}

	}

	private int renderSortedRenderers(int i1, int i2, int i3, double d4) {
		this.field_1415_R.clear();
		int i6 = 0;

		for(int i7 = i1; i7 < i2; ++i7) {
			if(i3 == 0) {
				++this.renderersLoaded;
				if(this.sortedWorldRenderers[i7].skipRenderPass[i3]) {
					++this.renderersSkippingRenderPass;
				} else if(!this.sortedWorldRenderers[i7].isInFrustum) {
					++this.renderersBeingClipped;
				} else if(this.occlusionEnabled && !this.sortedWorldRenderers[i7].isVisible) {
					++this.renderersBeingOccluded;
				} else {
					++this.renderersBeingRendered;
				}
			}

			if(!this.sortedWorldRenderers[i7].skipRenderPass[i3] && this.sortedWorldRenderers[i7].isInFrustum && (!this.occlusionEnabled || this.sortedWorldRenderers[i7].isVisible)) {
				int i8 = this.sortedWorldRenderers[i7].getGLCallListForPass(i3);
				if(i8 >= 0) {
					this.field_1415_R.add(this.sortedWorldRenderers[i7]);
					++i6;
				}
			}
		}

		EntityLiving entityLiving19 = this.mc.renderViewEntity;
		double d20 = entityLiving19.lastTickPosX + (entityLiving19.posX - entityLiving19.lastTickPosX) * d4;
		double d10 = entityLiving19.lastTickPosY + (entityLiving19.posY - entityLiving19.lastTickPosY) * d4;
		double d12 = entityLiving19.lastTickPosZ + (entityLiving19.posZ - entityLiving19.lastTickPosZ) * d4;
		int i14 = 0;

		int i15;
		for(i15 = 0; i15 < this.field_1414_S.length; ++i15) {
			this.field_1414_S[i15].func_859_b();
		}

		for(i15 = 0; i15 < this.field_1415_R.size(); ++i15) {
			WorldRenderer worldRenderer16 = (WorldRenderer)this.field_1415_R.get(i15);
			int i17 = -1;

			for(int i18 = 0; i18 < i14; ++i18) {
				if(this.field_1414_S[i18].func_862_a(worldRenderer16.field_1755_i, worldRenderer16.field_1754_j, worldRenderer16.field_1753_k)) {
					i17 = i18;
				}
			}

			if(i17 < 0) {
				i17 = i14++;
				this.field_1414_S[i17].func_861_a(worldRenderer16.field_1755_i, worldRenderer16.field_1754_j, worldRenderer16.field_1753_k, d20, d10, d12);
			}

			this.field_1414_S[i17].func_858_a(worldRenderer16.getGLCallListForPass(i3));
		}

		this.func_944_a(i3, d4);
		return i6;
	}

	public void func_944_a(int i1, double d2) {
		for(int i4 = 0; i4 < this.field_1414_S.length; ++i4) {
			this.field_1414_S[i4].func_860_a();
		}

	}

	public void updateClouds() {
		++this.cloudOffsetX;
	}

	public void renderSky(float f1) {
		if(!this.mc.theWorld.worldProvider.isNether) {
			GL11.glDisable(GL11.GL_TEXTURE_2D);
			Vec3D vec3D2 = this.worldObj.func_4079_a(this.mc.renderViewEntity, f1);
			float f3 = (float)vec3D2.xCoord;
			float f4 = (float)vec3D2.yCoord;
			float f5 = (float)vec3D2.zCoord;
			float f6;
			float f7;
			if(this.mc.gameSettings.anaglyph) {
				float f8 = (f3 * 30.0F + f4 * 59.0F + f5 * 11.0F) / 100.0F;
				f6 = (f3 * 30.0F + f4 * 70.0F) / 100.0F;
				f7 = (f3 * 30.0F + f5 * 70.0F) / 100.0F;
				f3 = f8;
				f4 = f6;
				f5 = f7;
			}

			GL11.glColor3f(f3, f4, f5);
			Tessellator tessellator15 = Tessellator.instance;
			GL11.glDepthMask(false);
			GL11.glEnable(GL11.GL_FOG);
			GL11.glColor3f(f3, f4, f5);
			GL11.glCallList(this.field_1433_z);
			GL11.glDisable(GL11.GL_FOG);
			GL11.glDisable(GL11.GL_ALPHA_TEST);
			GL11.glEnable(GL11.GL_BLEND);
			GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
			float[] f9 = this.worldObj.worldProvider.calcSunriseSunsetColors(this.worldObj.getCelestialAngle(f1), f1);
			float f10;
			float f11;
			if(f9 != null) {
				GL11.glDisable(GL11.GL_TEXTURE_2D);
				GL11.glShadeModel(GL11.GL_SMOOTH);
				GL11.glPushMatrix();
				GL11.glRotatef(90.0F, 1.0F, 0.0F, 0.0F);
				f7 = this.worldObj.getCelestialAngle(f1);
				GL11.glRotatef(f7 > 0.5F ? 180.0F : 0.0F, 0.0F, 0.0F, 1.0F);
				tessellator15.startDrawing(6);
				tessellator15.setColorRGBA_F(f9[0], f9[1], f9[2], f9[3]);
				tessellator15.addVertex(0.0D, 100.0D, 0.0D);
				byte b12 = 16;
				tessellator15.setColorRGBA_F(f9[0], f9[1], f9[2], 0.0F);

				for(int i13 = 0; i13 <= b12; ++i13) {
					f10 = (float)i13 * (float)Math.PI * 2.0F / (float)b12;
					f11 = MathHelper.sin(f10);
					float f14 = MathHelper.cos(f10);
					tessellator15.addVertex((double)(f11 * 120.0F), (double)(f14 * 120.0F), (double)(-f14 * 40.0F * f9[3]));
				}

				tessellator15.draw();
				GL11.glPopMatrix();
				GL11.glShadeModel(GL11.GL_FLAT);
			}

			GL11.glEnable(GL11.GL_TEXTURE_2D);
			GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);
			GL11.glPushMatrix();
			f6 = 1.0F - this.worldObj.func_27162_g(f1);
			f7 = 0.0F;
			float f16 = 0.0F;
			float f17 = 0.0F;
			GL11.glColor4f(1.0F, 1.0F, 1.0F, f6);
			GL11.glTranslatef(f7, f16, f17);
			GL11.glRotatef(0.0F, 0.0F, 0.0F, 1.0F);
			GL11.glRotatef(this.worldObj.getCelestialAngle(f1) * 360.0F, 1.0F, 0.0F, 0.0F);
			f10 = 30.0F;
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.renderEngine.getTexture("/terrain/sun.png"));
			tessellator15.startDrawingQuads();
			tessellator15.addVertexWithUV((double)(-f10), 100.0D, (double)(-f10), 0.0D, 0.0D);
			tessellator15.addVertexWithUV((double)f10, 100.0D, (double)(-f10), 1.0D, 0.0D);
			tessellator15.addVertexWithUV((double)f10, 100.0D, (double)f10, 1.0D, 1.0D);
			tessellator15.addVertexWithUV((double)(-f10), 100.0D, (double)f10, 0.0D, 1.0D);
			tessellator15.draw();
			f10 = 20.0F;
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.renderEngine.getTexture("/terrain/moon.png"));
			tessellator15.startDrawingQuads();
			tessellator15.addVertexWithUV((double)(-f10), -100.0D, (double)f10, 1.0D, 1.0D);
			tessellator15.addVertexWithUV((double)f10, -100.0D, (double)f10, 0.0D, 1.0D);
			tessellator15.addVertexWithUV((double)f10, -100.0D, (double)(-f10), 0.0D, 0.0D);
			tessellator15.addVertexWithUV((double)(-f10), -100.0D, (double)(-f10), 1.0D, 0.0D);
			tessellator15.draw();
			GL11.glDisable(GL11.GL_TEXTURE_2D);
			f11 = this.worldObj.getStarBrightness(f1) * f6;
			if(f11 > 0.0F) {
				GL11.glColor4f(f11, f11, f11, f11);
				GL11.glCallList(this.starGLCallList);
			}

			GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
			GL11.glDisable(GL11.GL_BLEND);
			GL11.glEnable(GL11.GL_ALPHA_TEST);
			GL11.glEnable(GL11.GL_FOG);
			GL11.glPopMatrix();
			GL11.glColor3f(f3 * 0.2F + 0.04F, f4 * 0.2F + 0.04F, f5 * 0.6F + 0.1F);
			GL11.glDisable(GL11.GL_TEXTURE_2D);
			GL11.glCallList(this.field_1432_A);
			GL11.glEnable(GL11.GL_TEXTURE_2D);
			GL11.glDepthMask(true);
		}

	}

	public void renderClouds(float f1) {
		if(!this.mc.theWorld.worldProvider.isNether) {
			if(this.mc.gameSettings.fancyGraphics) {
				this.renderCloudsFancy(f1);
			} else {
				GL11.glDisable(GL11.GL_CULL_FACE);
				float f2 = (float)(this.mc.renderViewEntity.lastTickPosY + (this.mc.renderViewEntity.posY - this.mc.renderViewEntity.lastTickPosY) * (double)f1);
				byte b3 = 32;
				int i4 = 256 / b3;
				Tessellator tessellator5 = Tessellator.instance;
				GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.renderEngine.getTexture("/environment/clouds.png"));
				GL11.glEnable(GL11.GL_BLEND);
				GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
				Vec3D vec3D6 = this.worldObj.func_628_d(f1);
				float f7 = (float)vec3D6.xCoord;
				float f8 = (float)vec3D6.yCoord;
				float f9 = (float)vec3D6.zCoord;
				float f10;
				if(this.mc.gameSettings.anaglyph) {
					f10 = (f7 * 30.0F + f8 * 59.0F + f9 * 11.0F) / 100.0F;
					float f11 = (f7 * 30.0F + f8 * 70.0F) / 100.0F;
					float f12 = (f7 * 30.0F + f9 * 70.0F) / 100.0F;
					f7 = f10;
					f8 = f11;
					f9 = f12;
				}

				f10 = 4.8828125E-4F;
				double d22 = this.mc.renderViewEntity.prevPosX + (this.mc.renderViewEntity.posX - this.mc.renderViewEntity.prevPosX) * (double)f1 + (double)(((float)this.cloudOffsetX + f1) * 0.03F);
				double d13 = this.mc.renderViewEntity.prevPosZ + (this.mc.renderViewEntity.posZ - this.mc.renderViewEntity.prevPosZ) * (double)f1;
				int i15 = MathHelper.floor_double(d22 / 2048.0D);
				int i16 = MathHelper.floor_double(d13 / 2048.0D);
				d22 -= (double)(i15 * 2048);
				d13 -= (double)(i16 * 2048);
				float f17 = 120.0F - f2 + 0.33F;
				float f18 = (float)(d22 * (double)f10);
				float f19 = (float)(d13 * (double)f10);
				tessellator5.startDrawingQuads();
				tessellator5.setColorRGBA_F(f7, f8, f9, 0.8F);

				for(int i20 = -b3 * i4; i20 < b3 * i4; i20 += b3) {
					for(int i21 = -b3 * i4; i21 < b3 * i4; i21 += b3) {
						tessellator5.addVertexWithUV((double)(i20 + 0), (double)f17, (double)(i21 + b3), (double)((float)(i20 + 0) * f10 + f18), (double)((float)(i21 + b3) * f10 + f19));
						tessellator5.addVertexWithUV((double)(i20 + b3), (double)f17, (double)(i21 + b3), (double)((float)(i20 + b3) * f10 + f18), (double)((float)(i21 + b3) * f10 + f19));
						tessellator5.addVertexWithUV((double)(i20 + b3), (double)f17, (double)(i21 + 0), (double)((float)(i20 + b3) * f10 + f18), (double)((float)(i21 + 0) * f10 + f19));
						tessellator5.addVertexWithUV((double)(i20 + 0), (double)f17, (double)(i21 + 0), (double)((float)(i20 + 0) * f10 + f18), (double)((float)(i21 + 0) * f10 + f19));
					}
				}

				tessellator5.draw();
				GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
				GL11.glDisable(GL11.GL_BLEND);
				GL11.glEnable(GL11.GL_CULL_FACE);
			}
		}

	}

	public boolean func_27307_a(double d1, double d3, double d5, float f7) {
		return false;
	}

	public void renderCloudsFancy(float f1) {
		GL11.glDisable(GL11.GL_CULL_FACE);
		float f2 = (float)(this.mc.renderViewEntity.lastTickPosY + (this.mc.renderViewEntity.posY - this.mc.renderViewEntity.lastTickPosY) * (double)f1);
		Tessellator tessellator3 = Tessellator.instance;
		float f4 = 12.0F;
		float f5 = 4.0F;
		double d6 = (this.mc.renderViewEntity.prevPosX + (this.mc.renderViewEntity.posX - this.mc.renderViewEntity.prevPosX) * (double)f1 + (double)(((float)this.cloudOffsetX + f1) * 0.03F)) / (double)f4;
		double d8 = (this.mc.renderViewEntity.prevPosZ + (this.mc.renderViewEntity.posZ - this.mc.renderViewEntity.prevPosZ) * (double)f1) / (double)f4 + (double)0.33F;
		float f10 = 108.0F - f2 + 0.33F;
		int i11 = MathHelper.floor_double(d6 / 2048.0D);
		int i12 = MathHelper.floor_double(d8 / 2048.0D);
		d6 -= (double)(i11 * 2048);
		d8 -= (double)(i12 * 2048);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.renderEngine.getTexture("/environment/clouds.png"));
		GL11.glEnable(GL11.GL_BLEND);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		Vec3D vec3D13 = this.worldObj.func_628_d(f1);
		float f14 = (float)vec3D13.xCoord;
		float f15 = (float)vec3D13.yCoord;
		float f16 = (float)vec3D13.zCoord;
		float f17;
		float f18;
		float f19;
		if(this.mc.gameSettings.anaglyph) {
			f17 = (f14 * 30.0F + f15 * 59.0F + f16 * 11.0F) / 100.0F;
			f18 = (f14 * 30.0F + f15 * 70.0F) / 100.0F;
			f19 = (f14 * 30.0F + f16 * 70.0F) / 100.0F;
			f14 = f17;
			f15 = f18;
			f16 = f19;
		}

		f17 = (float)(d6 * 0.0D);
		f18 = (float)(d8 * 0.0D);
		f19 = 0.00390625F;
		f17 = (float)MathHelper.floor_double(d6) * f19;
		f18 = (float)MathHelper.floor_double(d8) * f19;
		float f20 = (float)(d6 - (double)MathHelper.floor_double(d6));
		float f21 = (float)(d8 - (double)MathHelper.floor_double(d8));
		byte b22 = 8;
		byte b23 = 3;
		float f24 = 9.765625E-4F;
		GL11.glScalef(f4, 1.0F, f4);

		for(int i25 = 0; i25 < 2; ++i25) {
			if(i25 == 0) {
				GL11.glColorMask(false, false, false, false);
			} else {
				GL11.glColorMask(true, true, true, true);
			}

			for(int i26 = -b23 + 1; i26 <= b23; ++i26) {
				for(int i27 = -b23 + 1; i27 <= b23; ++i27) {
					tessellator3.startDrawingQuads();
					float f28 = (float)(i26 * b22);
					float f29 = (float)(i27 * b22);
					float f30 = f28 - f20;
					float f31 = f29 - f21;
					if(f10 > -f5 - 1.0F) {
						tessellator3.setColorRGBA_F(f14 * 0.7F, f15 * 0.7F, f16 * 0.7F, 0.8F);
						tessellator3.setNormal(0.0F, -1.0F, 0.0F);
						tessellator3.addVertexWithUV((double)(f30 + 0.0F), (double)(f10 + 0.0F), (double)(f31 + (float)b22), (double)((f28 + 0.0F) * f19 + f17), (double)((f29 + (float)b22) * f19 + f18));
						tessellator3.addVertexWithUV((double)(f30 + (float)b22), (double)(f10 + 0.0F), (double)(f31 + (float)b22), (double)((f28 + (float)b22) * f19 + f17), (double)((f29 + (float)b22) * f19 + f18));
						tessellator3.addVertexWithUV((double)(f30 + (float)b22), (double)(f10 + 0.0F), (double)(f31 + 0.0F), (double)((f28 + (float)b22) * f19 + f17), (double)((f29 + 0.0F) * f19 + f18));
						tessellator3.addVertexWithUV((double)(f30 + 0.0F), (double)(f10 + 0.0F), (double)(f31 + 0.0F), (double)((f28 + 0.0F) * f19 + f17), (double)((f29 + 0.0F) * f19 + f18));
					}

					if(f10 <= f5 + 1.0F) {
						tessellator3.setColorRGBA_F(f14, f15, f16, 0.8F);
						tessellator3.setNormal(0.0F, 1.0F, 0.0F);
						tessellator3.addVertexWithUV((double)(f30 + 0.0F), (double)(f10 + f5 - f24), (double)(f31 + (float)b22), (double)((f28 + 0.0F) * f19 + f17), (double)((f29 + (float)b22) * f19 + f18));
						tessellator3.addVertexWithUV((double)(f30 + (float)b22), (double)(f10 + f5 - f24), (double)(f31 + (float)b22), (double)((f28 + (float)b22) * f19 + f17), (double)((f29 + (float)b22) * f19 + f18));
						tessellator3.addVertexWithUV((double)(f30 + (float)b22), (double)(f10 + f5 - f24), (double)(f31 + 0.0F), (double)((f28 + (float)b22) * f19 + f17), (double)((f29 + 0.0F) * f19 + f18));
						tessellator3.addVertexWithUV((double)(f30 + 0.0F), (double)(f10 + f5 - f24), (double)(f31 + 0.0F), (double)((f28 + 0.0F) * f19 + f17), (double)((f29 + 0.0F) * f19 + f18));
					}

					tessellator3.setColorRGBA_F(f14 * 0.9F, f15 * 0.9F, f16 * 0.9F, 0.8F);
					int i32;
					if(i26 > -1) {
						tessellator3.setNormal(-1.0F, 0.0F, 0.0F);

						for(i32 = 0; i32 < b22; ++i32) {
							tessellator3.addVertexWithUV((double)(f30 + (float)i32 + 0.0F), (double)(f10 + 0.0F), (double)(f31 + (float)b22), (double)((f28 + (float)i32 + 0.5F) * f19 + f17), (double)((f29 + (float)b22) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + (float)i32 + 0.0F), (double)(f10 + f5), (double)(f31 + (float)b22), (double)((f28 + (float)i32 + 0.5F) * f19 + f17), (double)((f29 + (float)b22) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + (float)i32 + 0.0F), (double)(f10 + f5), (double)(f31 + 0.0F), (double)((f28 + (float)i32 + 0.5F) * f19 + f17), (double)((f29 + 0.0F) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + (float)i32 + 0.0F), (double)(f10 + 0.0F), (double)(f31 + 0.0F), (double)((f28 + (float)i32 + 0.5F) * f19 + f17), (double)((f29 + 0.0F) * f19 + f18));
						}
					}

					if(i26 <= 1) {
						tessellator3.setNormal(1.0F, 0.0F, 0.0F);

						for(i32 = 0; i32 < b22; ++i32) {
							tessellator3.addVertexWithUV((double)(f30 + (float)i32 + 1.0F - f24), (double)(f10 + 0.0F), (double)(f31 + (float)b22), (double)((f28 + (float)i32 + 0.5F) * f19 + f17), (double)((f29 + (float)b22) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + (float)i32 + 1.0F - f24), (double)(f10 + f5), (double)(f31 + (float)b22), (double)((f28 + (float)i32 + 0.5F) * f19 + f17), (double)((f29 + (float)b22) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + (float)i32 + 1.0F - f24), (double)(f10 + f5), (double)(f31 + 0.0F), (double)((f28 + (float)i32 + 0.5F) * f19 + f17), (double)((f29 + 0.0F) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + (float)i32 + 1.0F - f24), (double)(f10 + 0.0F), (double)(f31 + 0.0F), (double)((f28 + (float)i32 + 0.5F) * f19 + f17), (double)((f29 + 0.0F) * f19 + f18));
						}
					}

					tessellator3.setColorRGBA_F(f14 * 0.8F, f15 * 0.8F, f16 * 0.8F, 0.8F);
					if(i27 > -1) {
						tessellator3.setNormal(0.0F, 0.0F, -1.0F);

						for(i32 = 0; i32 < b22; ++i32) {
							tessellator3.addVertexWithUV((double)(f30 + 0.0F), (double)(f10 + f5), (double)(f31 + (float)i32 + 0.0F), (double)((f28 + 0.0F) * f19 + f17), (double)((f29 + (float)i32 + 0.5F) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + (float)b22), (double)(f10 + f5), (double)(f31 + (float)i32 + 0.0F), (double)((f28 + (float)b22) * f19 + f17), (double)((f29 + (float)i32 + 0.5F) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + (float)b22), (double)(f10 + 0.0F), (double)(f31 + (float)i32 + 0.0F), (double)((f28 + (float)b22) * f19 + f17), (double)((f29 + (float)i32 + 0.5F) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + 0.0F), (double)(f10 + 0.0F), (double)(f31 + (float)i32 + 0.0F), (double)((f28 + 0.0F) * f19 + f17), (double)((f29 + (float)i32 + 0.5F) * f19 + f18));
						}
					}

					if(i27 <= 1) {
						tessellator3.setNormal(0.0F, 0.0F, 1.0F);

						for(i32 = 0; i32 < b22; ++i32) {
							tessellator3.addVertexWithUV((double)(f30 + 0.0F), (double)(f10 + f5), (double)(f31 + (float)i32 + 1.0F - f24), (double)((f28 + 0.0F) * f19 + f17), (double)((f29 + (float)i32 + 0.5F) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + (float)b22), (double)(f10 + f5), (double)(f31 + (float)i32 + 1.0F - f24), (double)((f28 + (float)b22) * f19 + f17), (double)((f29 + (float)i32 + 0.5F) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + (float)b22), (double)(f10 + 0.0F), (double)(f31 + (float)i32 + 1.0F - f24), (double)((f28 + (float)b22) * f19 + f17), (double)((f29 + (float)i32 + 0.5F) * f19 + f18));
							tessellator3.addVertexWithUV((double)(f30 + 0.0F), (double)(f10 + 0.0F), (double)(f31 + (float)i32 + 1.0F - f24), (double)((f28 + 0.0F) * f19 + f17), (double)((f29 + (float)i32 + 0.5F) * f19 + f18));
						}
					}

					tessellator3.draw();
				}
			}
		}

		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		GL11.glDisable(GL11.GL_BLEND);
		GL11.glEnable(GL11.GL_CULL_FACE);
	}

	public boolean updateRenderers(EntityLiving entityLiving1, boolean z2) {
		boolean z3 = false;
		if(z3) {
			Collections.sort(this.worldRenderersToUpdate, new RenderSorter(entityLiving1));
			int i18 = this.worldRenderersToUpdate.size() - 1;
			int i19 = this.worldRenderersToUpdate.size();

			for(int i20 = 0; i20 < i19; ++i20) {
				WorldRenderer worldRenderer21 = (WorldRenderer)this.worldRenderersToUpdate.get(i18 - i20);
				if(!z2) {
					if(worldRenderer21.distanceToEntitySquared(entityLiving1) > 256.0F) {
						if(worldRenderer21.isInFrustum) {
							if(i20 >= 3) {
								return false;
							}
						} else if(i20 >= 1) {
							return false;
						}
					}
				} else if(!worldRenderer21.isInFrustum) {
					continue;
				}

				worldRenderer21.updateRenderer();
				this.worldRenderersToUpdate.remove(worldRenderer21);
				worldRenderer21.needsUpdate = false;
			}

			return this.worldRenderersToUpdate.size() == 0;
		} else {
			byte b4 = 2;
			RenderSorter renderSorter5 = new RenderSorter(entityLiving1);
			WorldRenderer[] worldRenderer6 = new WorldRenderer[b4];
			ArrayList arrayList7 = null;
			int i8 = this.worldRenderersToUpdate.size();
			int i9 = 0;

			int i10;
			WorldRenderer worldRenderer11;
			int i12;
			int i13;
			label169:
			for(i10 = 0; i10 < i8; ++i10) {
				worldRenderer11 = (WorldRenderer)this.worldRenderersToUpdate.get(i10);
				if(!z2) {
					if(worldRenderer11.distanceToEntitySquared(entityLiving1) > 256.0F) {
						for(i12 = 0; i12 < b4 && (worldRenderer6[i12] == null || renderSorter5.func_993_a(worldRenderer6[i12], worldRenderer11) <= 0); ++i12) {
						}

						--i12;
						if(i12 <= 0) {
							continue;
						}

						i13 = i12;

						while(true) {
							--i13;
							if(i13 == 0) {
								worldRenderer6[i12] = worldRenderer11;
								continue label169;
							}

							worldRenderer6[i13 - 1] = worldRenderer6[i13];
						}
					}
				} else if(!worldRenderer11.isInFrustum) {
					continue;
				}

				if(arrayList7 == null) {
					arrayList7 = new ArrayList();
				}

				++i9;
				arrayList7.add(worldRenderer11);
				this.worldRenderersToUpdate.set(i10, (Object)null);
			}

			if(arrayList7 != null) {
				if(arrayList7.size() > 1) {
					Collections.sort(arrayList7, renderSorter5);
				}

				for(i10 = arrayList7.size() - 1; i10 >= 0; --i10) {
					worldRenderer11 = (WorldRenderer)arrayList7.get(i10);
					worldRenderer11.updateRenderer();
					worldRenderer11.needsUpdate = false;
				}
			}

			i10 = 0;

			int i14;
			WorldRenderer worldRenderer15;
			for(i14 = b4 - 1; i14 >= 0; --i14) {
				worldRenderer15 = worldRenderer6[i14];
				if(worldRenderer15 != null) {
					if(!worldRenderer15.isInFrustum && i14 != b4 - 1) {
						worldRenderer6[i14] = null;
						worldRenderer6[0] = null;
						break;
					}

					worldRenderer6[i14].updateRenderer();
					worldRenderer6[i14].needsUpdate = false;
					++i10;
				}
			}

			i14 = 0;
			i12 = 0;

			for(i13 = this.worldRenderersToUpdate.size(); i14 != i13; ++i14) {
				worldRenderer15 = (WorldRenderer)this.worldRenderersToUpdate.get(i14);
				if(worldRenderer15 != null) {
					boolean z16 = false;

					for(int i17 = 0; i17 < b4 && !z16; ++i17) {
						if(worldRenderer15 == worldRenderer6[i17]) {
							z16 = true;
						}
					}

					if(!z16) {
						if(i12 != i14) {
							this.worldRenderersToUpdate.set(i12, worldRenderer15);
						}

						++i12;
					}
				}
			}

			while(true) {
				--i14;
				if(i14 < i12) {
					return i8 == i9 + i10;
				}

				this.worldRenderersToUpdate.remove(i14);
			}
		}
	}

	public void func_959_a(EntityPlayer entityPlayer1, MovingObjectPosition movingObjectPosition2, int i3, ItemStack itemStack4, float f5) {
		Tessellator tessellator6 = Tessellator.instance;
		GL11.glEnable(GL11.GL_BLEND);
		GL11.glEnable(GL11.GL_ALPHA_TEST);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, (MathHelper.sin((float)System.currentTimeMillis() / 100.0F) * 0.2F + 0.4F) * 0.5F);
		int i7;
		if(i3 == 0) {
			if(this.field_1450_i > 0.0F) {
				GL11.glBlendFunc(GL11.GL_DST_COLOR, GL11.GL_SRC_COLOR);
				int i8 = this.renderEngine.getTexture("/terrain.png");
				GL11.glBindTexture(GL11.GL_TEXTURE_2D, i8);
				GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.5F);
				GL11.glPushMatrix();
				i7 = this.worldObj.getBlockId(movingObjectPosition2.blockX, movingObjectPosition2.blockY, movingObjectPosition2.blockZ);
				Block block9 = i7 > 0 ? Block.blocksList[i7] : null;
				GL11.glDisable(GL11.GL_ALPHA_TEST);
				GL11.glPolygonOffset(-3.0F, -3.0F);
				GL11.glEnable(GL11.GL_POLYGON_OFFSET_FILL);
				tessellator6.startDrawingQuads();
				double d10 = entityPlayer1.lastTickPosX + (entityPlayer1.posX - entityPlayer1.lastTickPosX) * (double)f5;
				double d12 = entityPlayer1.lastTickPosY + (entityPlayer1.posY - entityPlayer1.lastTickPosY) * (double)f5;
				double d14 = entityPlayer1.lastTickPosZ + (entityPlayer1.posZ - entityPlayer1.lastTickPosZ) * (double)f5;
				tessellator6.setTranslationD(-d10, -d12, -d14);
				tessellator6.disableColor();
				if(block9 == null) {
					block9 = Block.stone;
				}

				this.field_1438_u.renderBlockUsingTexture(block9, movingObjectPosition2.blockX, movingObjectPosition2.blockY, movingObjectPosition2.blockZ, 240 + (int)(this.field_1450_i * 10.0F));
				tessellator6.draw();
				tessellator6.setTranslationD(0.0D, 0.0D, 0.0D);
				GL11.glPolygonOffset(0.0F, 0.0F);
				GL11.glDisable(GL11.GL_POLYGON_OFFSET_FILL);
				GL11.glEnable(GL11.GL_ALPHA_TEST);
				GL11.glDepthMask(true);
				GL11.glPopMatrix();
			}
		} else if(itemStack4 != null) {
			GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
			float f16 = MathHelper.sin((float)System.currentTimeMillis() / 100.0F) * 0.2F + 0.8F;
			GL11.glColor4f(f16, f16, f16, MathHelper.sin((float)System.currentTimeMillis() / 200.0F) * 0.2F + 0.5F);
			i7 = this.renderEngine.getTexture("/terrain.png");
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, i7);
			int i17 = movingObjectPosition2.blockX;
			int i18 = movingObjectPosition2.blockY;
			int i11 = movingObjectPosition2.blockZ;
			if(movingObjectPosition2.sideHit == 0) {
				--i18;
			}

			if(movingObjectPosition2.sideHit == 1) {
				++i18;
			}

			if(movingObjectPosition2.sideHit == 2) {
				--i11;
			}

			if(movingObjectPosition2.sideHit == 3) {
				++i11;
			}

			if(movingObjectPosition2.sideHit == 4) {
				--i17;
			}

			if(movingObjectPosition2.sideHit == 5) {
				++i17;
			}
		}

		GL11.glDisable(GL11.GL_BLEND);
		GL11.glDisable(GL11.GL_ALPHA_TEST);
	}

	public void drawSelectionBox(EntityPlayer entityPlayer1, MovingObjectPosition movingObjectPosition2, int i3, ItemStack itemStack4, float f5) {
		if(i3 == 0 && movingObjectPosition2.typeOfHit == EnumMovingObjectType.TILE) {
			GL11.glEnable(GL11.GL_BLEND);
			GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
			GL11.glColor4f(0.0F, 0.0F, 0.0F, 0.4F);
			GL11.glLineWidth(2.0F);
			GL11.glDisable(GL11.GL_TEXTURE_2D);
			GL11.glDepthMask(false);
			float f6 = 0.002F;
			int i7 = this.worldObj.getBlockId(movingObjectPosition2.blockX, movingObjectPosition2.blockY, movingObjectPosition2.blockZ);
			if(i7 > 0) {
				Block.blocksList[i7].setBlockBoundsBasedOnState(this.worldObj, movingObjectPosition2.blockX, movingObjectPosition2.blockY, movingObjectPosition2.blockZ);
				double d8 = entityPlayer1.lastTickPosX + (entityPlayer1.posX - entityPlayer1.lastTickPosX) * (double)f5;
				double d10 = entityPlayer1.lastTickPosY + (entityPlayer1.posY - entityPlayer1.lastTickPosY) * (double)f5;
				double d12 = entityPlayer1.lastTickPosZ + (entityPlayer1.posZ - entityPlayer1.lastTickPosZ) * (double)f5;
				this.drawOutlinedBoundingBox(Block.blocksList[i7].getSelectedBoundingBoxFromPool(this.worldObj, movingObjectPosition2.blockX, movingObjectPosition2.blockY, movingObjectPosition2.blockZ).expand((double)f6, (double)f6, (double)f6).getOffsetBoundingBox(-d8, -d10, -d12));
			}

			GL11.glDepthMask(true);
			GL11.glEnable(GL11.GL_TEXTURE_2D);
			GL11.glDisable(GL11.GL_BLEND);
		}

	}

	private void drawOutlinedBoundingBox(AxisAlignedBB axisAlignedBB1) {
		Tessellator tessellator2 = Tessellator.instance;
		tessellator2.startDrawing(3);
		tessellator2.addVertex(axisAlignedBB1.minX, axisAlignedBB1.minY, axisAlignedBB1.minZ);
		tessellator2.addVertex(axisAlignedBB1.maxX, axisAlignedBB1.minY, axisAlignedBB1.minZ);
		tessellator2.addVertex(axisAlignedBB1.maxX, axisAlignedBB1.minY, axisAlignedBB1.maxZ);
		tessellator2.addVertex(axisAlignedBB1.minX, axisAlignedBB1.minY, axisAlignedBB1.maxZ);
		tessellator2.addVertex(axisAlignedBB1.minX, axisAlignedBB1.minY, axisAlignedBB1.minZ);
		tessellator2.draw();
		tessellator2.startDrawing(3);
		tessellator2.addVertex(axisAlignedBB1.minX, axisAlignedBB1.maxY, axisAlignedBB1.minZ);
		tessellator2.addVertex(axisAlignedBB1.maxX, axisAlignedBB1.maxY, axisAlignedBB1.minZ);
		tessellator2.addVertex(axisAlignedBB1.maxX, axisAlignedBB1.maxY, axisAlignedBB1.maxZ);
		tessellator2.addVertex(axisAlignedBB1.minX, axisAlignedBB1.maxY, axisAlignedBB1.maxZ);
		tessellator2.addVertex(axisAlignedBB1.minX, axisAlignedBB1.maxY, axisAlignedBB1.minZ);
		tessellator2.draw();
		tessellator2.startDrawing(1);
		tessellator2.addVertex(axisAlignedBB1.minX, axisAlignedBB1.minY, axisAlignedBB1.minZ);
		tessellator2.addVertex(axisAlignedBB1.minX, axisAlignedBB1.maxY, axisAlignedBB1.minZ);
		tessellator2.addVertex(axisAlignedBB1.maxX, axisAlignedBB1.minY, axisAlignedBB1.minZ);
		tessellator2.addVertex(axisAlignedBB1.maxX, axisAlignedBB1.maxY, axisAlignedBB1.minZ);
		tessellator2.addVertex(axisAlignedBB1.maxX, axisAlignedBB1.minY, axisAlignedBB1.maxZ);
		tessellator2.addVertex(axisAlignedBB1.maxX, axisAlignedBB1.maxY, axisAlignedBB1.maxZ);
		tessellator2.addVertex(axisAlignedBB1.minX, axisAlignedBB1.minY, axisAlignedBB1.maxZ);
		tessellator2.addVertex(axisAlignedBB1.minX, axisAlignedBB1.maxY, axisAlignedBB1.maxZ);
		tessellator2.draw();
	}

	public void func_949_a(int i1, int i2, int i3, int i4, int i5, int i6) {
		int i7 = MathHelper.bucketInt(i1, 16);
		int i8 = MathHelper.bucketInt(i2, 16);
		int i9 = MathHelper.bucketInt(i3, 16);
		int i10 = MathHelper.bucketInt(i4, 16);
		int i11 = MathHelper.bucketInt(i5, 16);
		int i12 = MathHelper.bucketInt(i6, 16);

		for(int i13 = i7; i13 <= i10; ++i13) {
			int i14 = i13 % this.renderChunksWide;
			if(i14 < 0) {
				i14 += this.renderChunksWide;
			}

			for(int i15 = i8; i15 <= i11; ++i15) {
				int i16 = i15 % this.renderChunksTall;
				if(i16 < 0) {
					i16 += this.renderChunksTall;
				}

				for(int i17 = i9; i17 <= i12; ++i17) {
					int i18 = i17 % this.renderChunksDeep;
					if(i18 < 0) {
						i18 += this.renderChunksDeep;
					}

					int i19 = (i18 * this.renderChunksTall + i16) * this.renderChunksWide + i14;
					WorldRenderer worldRenderer20 = this.worldRenderers[i19];
					if(!worldRenderer20.needsUpdate) {
						this.worldRenderersToUpdate.add(worldRenderer20);
						worldRenderer20.markDirty();
					}
				}
			}
		}

	}

	public void markBlockAndNeighborsNeedsUpdate(int i1, int i2, int i3) {
		this.func_949_a(i1 - 1, i2 - 1, i3 - 1, i1 + 1, i2 + 1, i3 + 1);
	}

	public void markBlockRangeNeedsUpdate(int i1, int i2, int i3, int i4, int i5, int i6) {
		this.func_949_a(i1 - 1, i2 - 1, i3 - 1, i4 + 1, i5 + 1, i6 + 1);
	}

	public void clipRenderersByFrustrum(ICamera iCamera1, float f2) {
		for(int i3 = 0; i3 < this.worldRenderers.length; ++i3) {
			if(!this.worldRenderers[i3].skipAllRenderPasses() && (!this.worldRenderers[i3].isInFrustum || (i3 + this.frustrumCheckOffset & 15) == 0)) {
				this.worldRenderers[i3].updateInFrustrum(iCamera1);
			}
		}

		++this.frustrumCheckOffset;
	}

	public void playRecord(String string1, int i2, int i3, int i4) {
		if(string1 != null) {
			this.mc.ingameGUI.setRecordPlayingMessage("C418 - " + string1);
		}

		this.mc.sndManager.playStreaming(string1, (float)i2, (float)i3, (float)i4, 1.0F, 1.0F);
	}

	public void playSound(String string1, double d2, double d4, double d6, float f8, float f9) {
		float f10 = 16.0F;
		if(f8 > 1.0F) {
			f10 *= f8;
		}

		if(this.mc.renderViewEntity.getDistanceSq(d2, d4, d6) < (double)(f10 * f10)) {
			this.mc.sndManager.playSound(string1, (float)d2, (float)d4, (float)d6, f8, f9);
		}

	}

	public void spawnParticle(String string1, double d2, double d4, double d6, double d8, double d10, double d12) {
		if(this.mc != null && this.mc.renderViewEntity != null && this.mc.effectRenderer != null) {
			double d14 = this.mc.renderViewEntity.posX - d2;
			double d16 = this.mc.renderViewEntity.posY - d4;
			double d18 = this.mc.renderViewEntity.posZ - d6;
			double d20 = 16.0D;
			if(d14 * d14 + d16 * d16 + d18 * d18 <= d20 * d20) {
				if(string1.equals("bubble")) {
					this.mc.effectRenderer.addEffect(new EntityBubbleFX(this.worldObj, d2, d4, d6, d8, d10, d12));
				} else if(string1.equals("smoke")) {
					this.mc.effectRenderer.addEffect(new EntitySmokeFX(this.worldObj, d2, d4, d6, d8, d10, d12));
				} else if(string1.equals("note")) {
					this.mc.effectRenderer.addEffect(new EntityNoteFX(this.worldObj, d2, d4, d6, d8, d10, d12));
				} else if(string1.equals("portal")) {
					this.mc.effectRenderer.addEffect(new EntityPortalFX(this.worldObj, d2, d4, d6, d8, d10, d12));
				} else if(string1.equals("explode")) {
					this.mc.effectRenderer.addEffect(new EntityExplodeFX(this.worldObj, d2, d4, d6, d8, d10, d12));
				} else if(string1.equals("flame")) {
					this.mc.effectRenderer.addEffect(new EntityFlameFX(this.worldObj, d2, d4, d6, d8, d10, d12));
				} else if(string1.equals("lava")) {
					this.mc.effectRenderer.addEffect(new EntityLavaFX(this.worldObj, d2, d4, d6));
				} else if(string1.equals("footstep")) {
					this.mc.effectRenderer.addEffect(new EntityFootStepFX(this.renderEngine, this.worldObj, d2, d4, d6));
				} else if(string1.equals("splash")) {
					this.mc.effectRenderer.addEffect(new EntitySplashFX(this.worldObj, d2, d4, d6, d8, d10, d12));
				} else if(string1.equals("largesmoke")) {
					this.mc.effectRenderer.addEffect(new EntitySmokeFX(this.worldObj, d2, d4, d6, d8, d10, d12, 2.5F));
				} else if(string1.equals("reddust")) {
					this.mc.effectRenderer.addEffect(new EntityReddustFX(this.worldObj, d2, d4, d6, (float)d8, (float)d10, (float)d12));
				} else if(string1.equals("snowballpoof")) {
					this.mc.effectRenderer.addEffect(new EntitySlimeFX(this.worldObj, d2, d4, d6, Item.snowball));
				} else if(string1.equals("snowshovel")) {
					this.mc.effectRenderer.addEffect(new EntitySnowShovelFX(this.worldObj, d2, d4, d6, d8, d10, d12));
				} else if(string1.equals("slime")) {
					this.mc.effectRenderer.addEffect(new EntitySlimeFX(this.worldObj, d2, d4, d6, Item.slimeBall));
				} else if(string1.equals("heart")) {
					this.mc.effectRenderer.addEffect(new EntityHeartFX(this.worldObj, d2, d4, d6, d8, d10, d12));
				}
			}
		}

	}

	public void obtainEntitySkin(Entity entity1) {
		entity1.updateCloak();
		if(entity1.skinUrl != null) {
			this.renderEngine.obtainImageData(entity1.skinUrl, new ImageBufferDownload());
		}

		if(entity1.cloakUrl != null) {
			this.renderEngine.obtainImageData(entity1.cloakUrl, new ImageBufferDownload());
		}

	}

	public void releaseEntitySkin(Entity entity1) {
		if(entity1.skinUrl != null) {
			this.renderEngine.releaseImageData(entity1.skinUrl);
		}

		if(entity1.cloakUrl != null) {
			this.renderEngine.releaseImageData(entity1.cloakUrl);
		}

	}

	public void updateAllRenderers() {
		for(int i1 = 0; i1 < this.worldRenderers.length; ++i1) {
			if(this.worldRenderers[i1].field_1747_A && !this.worldRenderers[i1].needsUpdate) {
				this.worldRenderersToUpdate.add(this.worldRenderers[i1]);
				this.worldRenderers[i1].markDirty();
			}
		}

	}

	public void doNothingWithTileEntity(int i1, int i2, int i3, TileEntity tileEntity4) {
	}
}
